
function CriticalityChart() {
	this.chart = null;
	this.container = null;
	this.title = '';
	this.yTitle = '';
	this.metricId = 0;
	this.metricSize = 0;
	this.series = [];
}

/**
 * 
 * @returns {undefined}
 */
// TODO: undanify
CriticalityChart.prototype.draw = function() {
	var container = this.container;
	var title = this.title;
	var yTitle = lang.line('label_chart_' + this.yTitle + '_js');
	var series = this.series;

	if (this.chart !== null) {
		this.chart.destroy();
	}

	Highcharts.setOptions({
		series: [{
				dataLabels: {
					style: {
						fontWeight: 'normal'
					}
				}
			}],
		chart: {
			events: {
				load: function() {
					this.renderer.image(IMG_URL + '/watermark_logo.gif', 450, 15, 185, 37).add(); // x=900px to move image off chart (approx div width minus right margin) adjust as needed
				}
			}
		}});

	var chartOptions = {
		chart: {
			renderTo: container[0],
			type: 'line',
			height: 450,
			zoomType: 'xy',
			plotBorderColor: '#999',
			plotBorderWidth: 1
		},
		title: {
			text: '', //lang.line('label_chart_' + title + '_js'),
			x: -20 //center
		},
		subtitle: {
			text: '', //'Reliability & Maintenance Engineering System',
			x: -20
		},
		xAxis: {
			//type: 'category',
			//type: 'datetime',
			//dateTimeLabelFormats: {// don't display the dummy year
			//	month: '%e. %b',
			//year: '%b'
			//},
			labels: {
				rotation: -60 // para que el texto del eje se vea ladeado
			}
//	    //reversed: false,
//	    gridLineWidth: 1,
//	    maxPadding: 0.05,
//	    tickInterval: 100
			//showLastLabel: true
		},
		yAxis: {
			title: {
				text: yTitle + ' (%)'
			},
			labels: {
				formatter: function() {
					return this.value + '%';
				}
			}
		},
		legend: {
			//layout: 'vertical',
			borderWidth: 0,
			maxHeight: 60
		},
		tooltip: {
			headerFormat: '<b>{series.name}</b><br/>',
			pointFormat: '{point.x} : {point.y}%'
		},
		plotOptions: {
			spline: {
				marker: {
					enable: false
				}
			}
		},
		series: series
	};

	chartOptions.chart.type = 'scatter';
	chartOptions.xAxis = {
		type: 'linear',
		title: {
			text: 'Indisponibilidad'
		},
		labels: {
			formatter: function() {
				return this.value + '%';
			}
		}
	};

	chartOptions.yAxis = {
		title: {
			text: 'Consecuencia'
		},
		labels: {
			formatter: function() {
				return this.value + '%';
			}
		}
	};

	this.chart = new Highcharts.Chart(chartOptions);
};

CriticalityChart.prototype.getFormattedSerie = function(indicator) {
	var points = [];
	for (var i = 0; i < indicator.indicator_data.length; i++) {

		var point_data = indicator.indicator_data[i];
		var jsonObj = JSON.parse(point_data.value);

		points.push([roundFloat(jsonObj.unavail * 100), roundFloat(jsonObj.consecuence * 100)]);

	}

	var seriesName = indicator.name + ' (' + indicator.alias + ')';

	// Extras son utilizados para guardar preferencias
	var seriesExtras = {
		indicator_type_id: indicator.indicator_type,
		report_id: indicator.report_id,
		metric_id: indicator.metric_id,
		subsystem_id: indicator.subsystem_id
	};

	return {name: seriesName, data: points, extras: seriesExtras};
};