
function GeneralOperationInfoChart() {
    this.chart = null;
    this.container = null;
    this.title = '';
    this.yTitle = '';
    this.metricId = 0;
    this.metricSize = 0;
    this.series = [];
}

GeneralOperationInfoChart.prototype.setSeries = function(series) {
    this.series = series;
};

/**
 * 
 * @returns {undefined}
 */
GeneralOperationInfoChart.prototype.draw = function() {
    var container = this.container;
    var title = this.title;
    var yTitle = this.yTitle;
    var series = this.series;

    if (this.chart !== null) {
	this.chart.destroy();
    }
    // Create the chart
    $(this.container).highcharts({
	chart: {
	    type: 'arearange',
	    zoomType: 'x'
	},
	title: {
	    text: title,
	    style: {"color": "#333333", "fontSize": "12px"}
	},
	exporting: {enabled: false},
	credits: {enabled: false},
	xAxis: {
	    type: 'datetime'
	},
	yAxis: {
	    title: null
	},
	tooltip: {
	    crosshairs: true,
	    shared: true,
	    valueSuffix: '%'
	},
	legend: {
	    enabled: false
	},
	series: [series]

    });
};

GeneralOperationInfoChart.prototype.destroy = function() {
    if (this.chart !== null) {
	this.chart.destroy();
	this.chart = null;
    }

    this.container = null; // Container debe ser removido de forma externa
    this.title = '';
    this.yTitle = '';
    this.metricId = 0;
    this.metricSize = 0;
    this.series = [];
    this.overlap = false;
};