
function RelativeProductionChart() {
	this.chart = null;
	this.container = null;
	this.title = '';
	this.yTitle = '';
	this.metricId = 0;
	this.metricSize = 0;
	this.series = [];
	this.xAxis = [];
}


RelativeProductionChart.prototype.setSeries = function(series) {
    this.series = series;
};

RelativeProductionChart.prototype.setXAxis = function(categories){
	this.xAxis = categories;
};

/**
 * 
 * @returns {undefined}
 */
// TODO: undanify
RelativeProductionChart.prototype.draw = function() {
	var container = this.container;
	var title = this.title;
	var yTitle = lang.line('label_chart_' + this.yTitle + '_js');
	var series = this.series;
	var categories = this.xAxis;

//	var categories = [lang.line('label_jan_js'),
//		lang.line('label_feb_js'),
//		lang.line('label_mar_js'),
//		lang.line('label_apr_js'),
//		lang.line('label_may_js'),
//		lang.line('label_jun_js'),
//		lang.line('label_jul_js'),
//		lang.line('label_aug_js'),
//		lang.line('label_sep_js'),
//		lang.line('label_oct_js'),
//		lang.line('label_nov_js'),
//		lang.line('label_dec_js')
//	];

	if (this.chart !== null) {
		this.chart.destroy();
	}

	Highcharts.setOptions({
		series: [{
				dataLabels: {
					style: {
						fontWeight: 'normal'
					}
				}
			}],
		chart: {
			events: {
				load: function() {
					this.renderer.image(IMG_URL + '/watermark_logo.gif', 450, 15, 185, 37).add(); // x=900px to move image off chart (approx div width minus right margin) adjust as needed
				}
			}
		}});
	
	var chartOptions = {
		chart: {
			renderTo: container[0],
			type: 'column',
			height: 200,
			plotBorderColor: '#999',
			plotBorderWidth: 1
		},
		title: {
			text: title,
			style: {"color": "#333333", "fontSize": "12px"}
		},
		subtitle: {
			text: '', //'Reliability & Maintenance Engineering System',
			x: -20
		},
		xAxis: {
			categories: categories
		},
		yAxis: {
			title: null,
			min: -100,
			max: 100
		},
		legend: {
			enabled: false
		},
		tooltip: {
			shared: true,
			valueSuffix: '%'
		},
		plotOptions: {
			series: {
				animation: false,
				lineWidth: 1,
				shadow: false,
				states: {
					hover: {
						lineWidth: 1
					}
				},
				marker: {
					radius: 1,
					states: {
						hover: {
							radius: 2
						}
					}
				},
				fillOpacity: 0.2
			},
			column: {
				negativeColor: '#EC1818',
				borderColor: 'silver'
			},
			spline: {
				marker: {
					enable: false
				}
			}
		},
		credits: {
			enabled: false
		},
		exporting: {
			enabled: false
		},
		series: series
	};

	this.chart = new Highcharts.Chart(chartOptions);
};