function LanguageManager() {
    this.current = '';
    this.dictionary = {};
    this.monthList = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
    this.weekList = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
}

LanguageManager.prototype.setCurrentLanguage = function(lang) {
    this.current = lang;
    this.updateLanguage();
};

LanguageManager.prototype.setDictionary = function(dictionary) {
    this.dictionary = dictionary;
};

/**
 * Obtiene la linea de forma similar al lang de codeigniter
 * @param {type} lookupKey
 * @returns {LanguageManager.dictionary}
 */
LanguageManager.prototype.line = function(lookupKey) {

    if (lookupKey in this.dictionary)
	return this.dictionary[lookupKey];

    return lookupKey;
};

LanguageManager.prototype.updateLanguage = function() {

    switch (this.current) {
	case 'es':
	    this.monthList = ['Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 'Julio', 'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre'];
	    this.weekList = ['Domingo', 'Lunes', 'Martes', 'Miércoles', 'Jueves', 'Viernes', 'Sábado'];
	    Highcharts.setOptions({
		lang: {
		    months: this.monthList,
		    weekdays: this.weekList,
		    loading: 'Cargando...',
		    exportButtonTitle: "Exportar",
		    printButtonTitle: "Importar",
		    rangeSelectorFrom: "De",
		    rangeSelectorTo: "A",
		    rangeSelectorZoom: "Periodo",
		    downloadPNG: 'Descargar gráfica PNG',
		    downloadJPEG: 'Descargar gráfica JPEG',
		    downloadPDF: 'Descargar gráfica PDF',
		    downloadSVG: 'Descargar gráfica SVG',
		    printChart: 'Imprimir gráfica',
		    thousandsSep: ",",
		    decimalPoint: '.'
		}
	    });
	    break;

	default:
	    Highcharts.setOptions({
		lang: {
		    months: ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'],
		    weekdays: ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'],
		    loading: 'Loading...',
		    exportButtonTitle: "Export",
		    printButtonTitle: "Import",
		    rangeSelectorFrom: "From",
		    rangeSelectorTo: "To",
		    rangeSelectorZoom: "Range",
		    downloadPNG: 'Download as PNG',
		    downloadJPEG: 'Download as JPEG',
		    downloadPDF: 'Download as PDF',
		    downloadSVG: 'Download as SVG',
		    printChart: 'Print Chart',
		    thousandsSep: ",",
		    decimalPoint: '.'
		}

	    });
	    break;


    }
};