
// Sobreescribe el comportamiento de las teclas de direccion para ejecutar evento selected en vez de hover al visitar un nodo.

$.jstree.core.prototype.bind = function() {
    this.element
	    .on("dblclick.jstree", function() {
		if (document.selection && document.selection.empty) {
		    document.selection.empty();
		}
		else {
		    if (window.getSelection) {
			var sel = window.getSelection();
			try {
			    sel.removeAllRanges();
			    sel.collapse();
			} catch (ignore) {
			}
		    }
		}
	    })
	    .on("click.jstree", ".jstree-ocl", $.proxy(function(e) {
		this.toggle_node(e.target);
	    }, this))
	    .on("click.jstree", ".jstree-anchor", $.proxy(function(e) {
		e.preventDefault();
		$(e.currentTarget).focus();
		this.activate_node(e.currentTarget, e);
	    }, this))
	    .on('keydown.jstree', '.jstree-anchor', $.proxy(function(e) {
		if (e.target.tagName === "INPUT") {
		    return true;
		}
		var o = null;
		switch (e.which) {
		    case 13:
		    case 32:
			e.type = "click";
			$(e.currentTarget).trigger(e);
			break;
		    case 37:
			e.preventDefault();
			if (this.is_open(e.currentTarget)) {
			    this.close_node(e.currentTarget);
			}
			else {
			    o = this.get_prev_dom(e.currentTarget);
			    if (o && o.length) {
				o.children('.jstree-anchor').focus();
			    }
			}
			break;
		    case 38:
			e.preventDefault();
			o = this.get_prev_dom(e.currentTarget);
			if (o && o.length) {
			    o.children('.jstree-anchor').focus();
			}
			break;
		    case 39:
			e.preventDefault();
			if (this.is_closed(e.currentTarget)) {
			    this.open_node(e.currentTarget, function(o) {
				this.get_node(o, true).children('.jstree-anchor').focus();
			    });
			}
			else {
			    o = this.get_next_dom(e.currentTarget);
			    if (o && o.length) {
				o.children('.jstree-anchor').focus();
			    }
			}
			break;
		    case 40:
			e.preventDefault();
			o = this.get_next_dom(e.currentTarget);
			if (o && o.length) {
			    o.children('.jstree-anchor').focus();
			}
			break;
			// delete
		    case 46:
			e.preventDefault();
			o = this.get_node(e.currentTarget);
			if (o && o.id && o.id !== '#') {
			    o = this.is_selected(o) ? this.get_selected() : o;
			    // this.delete_node(o);
			}
			break;
			// f2
		    case 113:
			e.preventDefault();
			o = this.get_node(e.currentTarget);
			/*!
			 if(o && o.id && o.id !== '#') {
			 // this.edit(o);
			 }
			 */
			break;
		    default:
			// console.log(e.which);
			break;
		}
	    }, this))
	    .on("load_node.jstree", $.proxy(function(e, data) {
		if (data.status) {
		    if (data.node.id === '#' && !this._data.core.loaded) {
			this._data.core.loaded = true;
			/**
			 * triggered after the root node is loaded for the first time
			 * @event
			 * @name loaded.jstree
			 */
			this.trigger("loaded");
		    }
		    if (!this._data.core.ready && !this.get_container_ul().find('.jstree-loading:eq(0)').length) {
			this._data.core.ready = true;
			if (this._data.core.selected.length) {
			    if (this.settings.core.expand_selected_onload) {
				var tmp = [], i, j;
				for (i = 0, j = this._data.core.selected.length; i < j; i++) {
				    tmp = tmp.concat(this._model.data[this._data.core.selected[i]].parents);
				}
				tmp = $.vakata.array_unique(tmp);
				for (i = 0, j = tmp.length; i < j; i++) {
				    this.open_node(tmp[i], false, 0);
				}
			    }
			    this.trigger('changed', {'action': 'ready', 'selected': this._data.core.selected});
			}
			/**
			 * triggered after all nodes are finished loading
			 * @event
			 * @name ready.jstree
			 */
			setTimeout($.proxy(function() {
			    this.trigger("ready");
			}, this), 0);
		    }
		}
	    }, this))
	    // THEME RELATED
	    .on("init.jstree", $.proxy(function() {
		var s = this.settings.core.themes;
		this._data.core.themes.dots = s.dots;
		this._data.core.themes.stripes = s.stripes;
		this._data.core.themes.icons = s.icons;
		this.set_theme(s.name || "default", s.url);
		this.set_theme_variant(s.variant);
	    }, this))
	    .on("loading.jstree", $.proxy(function() {
		this[ this._data.core.themes.dots ? "show_dots" : "hide_dots" ]();
		this[ this._data.core.themes.icons ? "show_icons" : "hide_icons" ]();
		this[ this._data.core.themes.stripes ? "show_stripes" : "hide_stripes" ]();
	    }, this))
	    .on('focus.jstree', '.jstree-anchor', $.proxy(function(e) {
		this.element.find('.jstree-hovered').not(e.currentTarget).mouseleave();
		//$(e.currentTarget).mouseenter();
		this.hover_node(e.currentTarget);
	    }, this))
	    .on('mouseenter.jstree', '.jstree-anchor', $.proxy(function(e) {
		//this.hover_node(e.currentTarget);

		var obj = this.get_node(e.currentTarget, true);
		if (!obj || !obj.length || obj.children('.jstree-hovered').length) {
		    return false;
		}
		var o = this.element.find('.jstree-hovered'), t = this.element;
		if (o && o.length) {
		    this.dehover_node(o);
		}

		obj.children('.jstree-anchor').addClass('jstree-hovered');

		//this.trigger('hover_node', { 'node' : this.get_node(obj) });
		setTimeout(function() {
		    t.attr('aria-activedescendant', obj[0].id);
		    obj.attr('aria-selected', true);
		}, 0);
	    }, this))
	    .on('mouseleave.jstree', '.jstree-anchor', $.proxy(function(e) {
		this.dehover_node(e.currentTarget);
	    }, this));
}