var map;
var operation = null;
var markersArrayDiv = [];
var geocoder = new google.maps.Geocoder();
var latlng1 = new google.maps.LatLng(-23.839808, -68.502197);
var treeListDiv = [];
var bigTree = [];
var markersAddArray = [];
var elevator = new google.maps.ElevationService();
var elevation;
var geolocation;
var id_grafo = null;
var latInitial = null;
var lngInitial = null;
var confOperation = null;
var areasMarkers = [];

function initialize() {

    generateCompanyTree(companyStructure, '#jstree');
    //opciones del mapa
    var mapOptions = {
	mapTypeId: google.maps.MapTypeId.ROADMAP, //Tipo de Mapa
	zoom: 4,
	panControl: false, //todos los controles desactivados por defecto
	zoomControl: false,
	mapTypeControl: false,
	streetViewControl: false,
	center: latlng1
    };

    // Variable Global Mapa
    map = new google.maps.Map(document.getElementById('map'), mapOptions);

    mapEventListeners();

    // Se crea el marcador para los marcadores del primer nivel
    var jsTreeNodes = app.getCompanyTree()._model.data;
    drawMarkers(jsTreeNodes, 1, false, false);

    // Crear otro thread para evitar bloquear la interfaz
    setTimeout(function() {
	app.loadGeneralData();
	setBasicView();
    }, 250);
}

function redrawCompanyTree() {

    indicatorsWrapper.destroy();
    $('#jstree_basic').hide();
    $('#jstree').show();
    //generateCompanyTree(companyStructure, '#jstree');
    $('.current-view').attr('href', 'javascript:setBasicView()').html(lang.line('task_enable_basic_view'));
    $('body').toggleClass('basic-view');
    $('.destroy-on-basic').remove();
    $('.hide-on-basic').show();
}

function setAdvancedView() {
    redrawCompanyTree();
}

function setBasicView() {

    indicatorsWrapper.destroy();

    $('.current-view').attr('href', 'javascript:redrawCompanyTree()').html(lang.line('task_enable_advanced_view'));
    $('body').toggleClass('basic-view');
    $('.destroy-on-basic').remove();
    $('.hide-on-basic').hide();
    $('#jstree').hide();
    generateDashboardCompanyTree(companyStructure, '#jstree_basic');
    $('#jstree_basic').show();

    function generateDashboardCompanyTree(tree, selector) {

	$(selector).jstree('destroy');
	$.jstree.defaults.checkbox.three_state = false;
	// Crear una instancia de js tree
	$(selector).jstree({'core': {
		data: tree,
		check_callback: true
	    },
	    checkbox: {
		keep_selected_style: true
	    },
	    types: {
		default: {
		    icon: IMG_URL + "/jstree_icons/Search.png"
		},
		graph: {
		    icon: IMG_URL + "/jstree_icons/corporation.png"
		},
		area: {
		    icon: IMG_URL + "/jstree_icons/equipPlant.png"
		},
		linearmachine: {
		    icon: IMG_URL + "/jstree_icons/line.png"
		},
		equipment: {
		    icon: IMG_URL + "/jstree_icons/equip.png"
		},
		standbymachine: {
		    icon: IMG_URL + "/jstree_icons/standby.png"
		},
		fractionmachine: {
		    icon: IMG_URL + "/jstree_icons/fraction.png"
		},
		redundantmachine: {
		    icon: IMG_URL + "/jstree_icons/redundant.png"
		},
		parallelmachine: {
		    icon: IMG_URL + "/jstree_icons/parallel.png"
		},
		stockpile: {
		    icon: IMG_URL + "/jstree_icons/stockpile.png"
		}
	    },
	    plugins: ["search", "state", "types"]
	});
	var to = false;
	$('#tree-search').keyup(function() {
	    if (to) {
		clearTimeout(to);
	    }
	    to = setTimeout(function() {
		var v = $('#tree-search').val();
		$(selector).jstree(true).search(v);
	    }, 250);
	});

	// Listener para click en elementos de jstree
	var dashboardLoadTimeout = null;
	$(selector)
		.on("hover_node.jstree", function(n, data) {
		    clearTimeout(dashboardLoadTimeout);
		    dashboardLoadTimeout = setTimeout(function() {
			showMainPanel(true);
			openGeneralInfoPanel(false);
			indicatorsWrapper.loadDashboard(data.node);
		    }, 450);
		})
		.on("activate_node.jstree", function(n, data) {
		    clearTimeout(dashboardLoadTimeout);
		    dashboardLoadTimeout = setTimeout(function() {
			showMainPanel(true);
			openGeneralInfoPanel(false);
			indicatorsWrapper.loadDashboard(data.node);
		    }, 450);
		});
    }
}

function drawMarkers(nodes, markerDrawLevel, append, adjustToBound) {
    if (!append) {
	clearMapOverlays();
    }

    for (var nodeId in nodes) {
	var node = nodes[nodeId];
	// Se rechaza el nodo raiz de jstree
	if (node.id === '#')
	    continue;

	// Se rechazan los subsystemas ya que no se deben graficar en el mapa
	if (node.original.node_type == NODE_TYPE_SUBSYSTEM)
	    continue;

	if (node.data.marker_level == markerDrawLevel && node.data.geodata.id_geo !== null) {
	    // Se prepara el marcador
	    var latlng = new google.maps.LatLng(node.data.geodata.lat, node.data.geodata.lng);
	    var icon = IMG_URL + '/map_icons/' + MARKERS_DEFAULT_ICONS[node.data.marker_level] + '' + MARKERS_DEFAULT_NEUTRAL_COLOR + '.png';
	    var selectedIcon = IMG_URL + '/map_icons/' + MARKERS_DEFAULT_ICONS[node.data.marker_level] + '' + MARKERS_DEFAULT_SELECTED_COLOR + '.png';

	    if (typeof node.data.marker !== 'undefined' && node.data.marker !== null) {
		icon = IMG_URL + '/map_icons/' + node.data.marker + MARKERS_DEFAULT_NEUTRAL_COLOR + '.png';
		selectedIcon = IMG_URL + '/map_icons/' + node.data.marker + MARKERS_DEFAULT_SELECTED_COLOR + '.png';
	    }

	    var marker = new google.maps.Marker({
		id: node.id,
		position: latlng,
		icon: icon,
		neutralIcon: icon,
		selectedIcon: selectedIcon,
		oid: node.original.oid,
		hasChilds: node.children.length > 0 && (node.original.node_type == NODE_TYPE_GRAPH), // Solo se pueden dibujar hijos de grafos
		isSelected: false
	    });

	    bindMarkerFunctions(marker, node);
	    areasMarkers.push(marker);

	    // Se dibuja el marcador
	    marker.setMap(map);
	}
    }

    // Se ajusta el zoom hacia los limites de los marcadores visibles
    if (adjustToBound) {
	adjustZoom(areasMarkers);
    }
}

function clearMapOverlays() {
    for (var i = 0; i < areasMarkers.length; i++) {
	areasMarkers[i].setMap(null);
    }
    areasMarkers.length = [];
}

function bindMarkerFunctions(marker, node) {

    var updateTimeout = null;
    var markerInfo = getInfoBox(node);
    var contextualMenu = getContextualMenu(node.original.oid);
    marker.setOptions({
	markerInfo: markerInfo,
	menu: contextualMenu
    });

    // Se abre el infobox
    google.maps.event.addListener(marker, 'mouseover', function() {
	markerInfo.open(map, marker);
	//app.getNodeInfo();
    });

    // Se seleccionan marcadores
    google.maps.event.addListener(marker, 'click', function() {

	// Se espera por un evento dobleclick
	updateTimeout = setTimeout(function() {
	    selectMarker(marker, node);
	}, 250);
    });

    // dobleclick: se centra el mapa y se setea title
    google.maps.event.addListener(marker, "dblclick", function(e) {
	// Cancelar evento single click
	clearTimeout(updateTimeout);

	map.setCenter(new google.maps.LatLng(marker.position.lat(), marker.position.lng()));

//		if (marker.hasChilds) {
//			var newNodes = [];
//			var jstree = $('#jstree').jstree(true);
//			var parentNode = jstree.get_node(marker.id);
//
//			for (var i = 0; i < parentNode.children.length; i++) {
//				newNodes.push(jstree.get_node(parentNode.children[i]));
//			}
//
//
//			if (newNodes.length > 0) {
//				drawMarkers(newNodes, 2, false, true); // TODO: eliminar constante 2
//			}
//
//		}

	app.drawOperationGeneralData(node, METRIC_TYPE_YTD);

	$('#tree-title').html(node.text);
    });

    // mouseout: cerrar el infobox
    google.maps.event.addListener(marker, 'mouseout', function() {
	markerInfo.close();
    });

    // rightclick: muestra el menu contextual
    google.maps.event.addListener(marker, "rightclick", function(event) {
	closeContextualMenus();
	markerInfo.close();

	selectMarker(marker, node);
	drawAttributes(node.data.attributes);
	//$('#attributes').hide();
	contextualMenu.open(map, marker);



	$('html').click(function() {
	    contextualMenu.close();
	});

	$('.contextual-box').click(function(event) {
	    event.stopPropagation();
	});

    });

}
function closeContextualMenus() {
    for (var i = 0; i < areasMarkers.length; i++) {
	areasMarkers[i].menu.close();
    }
}

function markersDisplay(markArray, show) {
    for (var i = 0; i < markArray.length; i++) {
	if (show) {
	    markArray[i].setMap(map);
	} else {
	    markArray[i].setMap(null);
	}
    }
}

var treeTypes = {
    default: {
	icon: IMG_URL + "/jstree_icons/Search.png"
    },
    graph: {
	icon: IMG_URL + "/jstree_icons/corporation.png"
    },
    area: {
	icon: IMG_URL + "/jstree_icons/equipPlant.png"
    },
    linearmachine: {
	icon: IMG_URL + "/jstree_icons/line.png"
    },
    equipment: {
	icon: IMG_URL + "/jstree_icons/equip.png"
    },
    standbymachine: {
	icon: IMG_URL + "/jstree_icons/standby.png"
    },
    fractionmachine: {
	icon: IMG_URL + "/jstree_icons/fraction.png"
    },
    redundantmachine: {
	icon: IMG_URL + "/jstree_icons/redundant.png"
    },
    parallelmachine: {
	icon: IMG_URL + "/jstree_icons/parallel.png"
    },
    stockpile: {
	icon: IMG_URL + "/jstree_icons/stockpile.png"
    }
};
function generateCompanyTree(tree, selector) {

    $(selector).jstree('destroy');
    $.jstree.defaults.checkbox.three_state = false;

    // Crear una instancia de js tree
    $(selector).jstree({'core': {
	    data: tree,
	    check_callback: true
	},
	checkbox: {
	    keep_selected_style: true
	},
	types: treeTypes,
	plugins: ["checkbox", "search", "state", "contextmenu", "types"],
	contextmenu: {
	    select_node: false,
	    items: function($node) {
		return {
		    LoadIndicators: {
			label: lang.line('task_load_indicators_js'),
			action: function(obj) {

			    var parentSelector = obj.reference.prevObject.selector;
			    app.getCompanyTree().select_node(parentSelector);
			    $('#get-indicators-button').click();

			}
		    },
		    Select: {
			label: lang.line('label_select_children_js'),
			action: function(obj) {

			    var parentSelector = obj.reference.prevObject.selector;
			    selectChildren(parentSelector, true, true);

			}
		    },
		    Deselect: {
			label: lang.line('label_deselect_children_js'),
			action: function(obj) {

			    var parentSelector = obj.reference.prevObject.selector;
			    deselectChildren(parentSelector, true, true);

			}
		    }
		};
	    }
	}
    });

    var companyTree = $(selector).jstree(true);
    app.setCompanyTree(companyTree);

    var to = false;
    $('#tree-search').keyup(function() {
	if (to) {
	    clearTimeout(to);
	}
	to = setTimeout(function() {
	    var v = $('#tree-search').val();
	    $('#jstree').jstree(true).search(v);
	}, 250);
    });

    // Listener para click en elementos de jstree
    $('#jstree').on("changed.jstree", function(e, data) {

	updateMarkersOnMap(data.selected);

	if ($('#id_grafo').val() !== '') {
	    $('#id_grafo').val(data.selected);
	}

	$('#get-indicators-button').prop('disabled', data.selected.length <= 0);
    });
}

function generateCompanyNodesTree(tree, selector) {

    $(selector).jstree('destroy');
    $.jstree.defaults.checkbox.three_state = false;

    // Crear una instancia de js tree
    $(selector).jstree({'core': {
	    data: tree,
	    check_callback: true
	},
	checkbox: {
	    keep_selected_style: true
	},
	types: {
	    default: {
		icon: IMG_URL + "/jstree_icons/Search.png"
	    },
	    graph: {
		icon: IMG_URL + "/jstree_icons/corporation.png"
	    },
	    area: {
		icon: IMG_URL + "/jstree_icons/equipPlant.png"
	    },
	    linearmachine: {
		icon: IMG_URL + "/jstree_icons/line.png"
	    },
	    equipment: {
		icon: IMG_URL + "/jstree_icons/equip.png"
	    },
	    standbymachine: {
		icon: IMG_URL + "/jstree_icons/standby.png"
	    },
	    fractionmachine: {
		icon: IMG_URL + "/jstree_icons/fraction.png"
	    },
	    redundantmachine: {
		icon: IMG_URL + "/jstree_icons/redundant.png"
	    },
	    parallelmachine: {
		icon: IMG_URL + "/jstree_icons/parallel.png"
	    },
	    stockpile: {
		icon: IMG_URL + "/jstree_icons/stockpile.png"
	    }
	},
	plugins: ["checkbox", "search", "state", "contextmenu", "types"],
	contextmenu: {
	    select_node: false,
	    items: function($node) {
		return {
		    LoadIndicators: {
			label: lang.line('task_load_indicators_js'),
			action: function(obj) {

			    var parentSelector = obj.reference.prevObject.selector;
			    app.getCompanyTree().select_node(parentSelector);
			    $('#get-indicators-button').click();

			}
		    },
		    Select: {
			label: lang.line('label_select_children_js'),
			action: function(obj) {

			    var parentSelector = obj.reference.prevObject.selector;
			    selectChildren(parentSelector, true, true);

			}
		    },
		    Deselect: {
			label: lang.line('label_deselect_children_js'),
			action: function(obj) {

			    var parentSelector = obj.reference.prevObject.selector;
			    deselectChildren(parentSelector, true, true);

			}
		    }
		};
	    }
	}
    });

    var companyTree = $(selector).jstree(true);
    app.setCompanyTree(companyTree);

    var to = false;
    $('#tree-search').keyup(function() {
	if (to) {
	    clearTimeout(to);
	}
	to = setTimeout(function() {
	    var v = $('#tree-search').val();
	    $('#jstree').jstree(true).search(v);
	}, 250);
    });
    $(selector).on("ready.jstree", function(e, data) {
	var company = app.getCompanyTree();
	var parentNode = company.get_node('#');
	var companyTreeArray = parentNode.children_d;

	for (var i = 0; i < companyTreeArray.length; i++) {
	    var nodeId = companyTreeArray[i];
	    var nodeTree = company.get_node(nodeId);

	    if (nodeTree.original.node_type == 1) {
		if (permissionExist(nodeTree.original.oid, plants)) {
		    company.select_node(nodeId);
		}

	    }
	    if (nodeTree.original.node_type == 0) {
		if (permissionExist(nodeTree.original.oid, operations)) {
		    company.select_node(nodeId);
		}
	    }



	}
    });
    // Listener para click en elementos de jstree
    $(selector).on("changed.jstree", function(e, data) {
	idsTree = data.selected;
//            alert(idsTree);
	//if ($('#id_grafo').val() != '') {
	plantsSelected = data.selected;
	companyTree = $(selector).jstree(true);
	var selectedPlants = [];
	for (var i = 0; i < plantsSelected.length; i++) {
	    var nodeSelected = companyTree.get_node(plantsSelected[i]);
	    selectedPlants.push(nodeSelected.original.node_type + '.' + nodeSelected.original.oid);
	}
	plantsSelectedCompressed = selectedPlants.join();
	$('#plants_selected').val(plantsSelectedCompressed);
	$('#id_grafo').val(data.selected);
	//}
    });




}



function getMarkerFromArray(markerId, haystack) {

    for (var i = 0; i < haystack.length; i++) {
	if (haystack[i].id === markerId)
	    return haystack[i];
    }
}

function adjustZoom(markersArray) {

    var bounds = new google.maps.LatLngBounds();
    for (var i = 0, marker; marker = markersArray[i]; i++) {
	bounds.extend(marker.getPosition());
    }

    map.initialZoom = true;
    map.fitBounds(bounds);
}

function placeMarker(myLatLng) {

    var marker;
    var lat = myLatLng.lat();
    var lng = myLatLng.lng();
    var locations = [];
    locations.push(location);
    var positionalRequest = {'locations': locations};
    var contentString = "Latitud: " + lat + ", Longitud: " + lng + "<br> Altitud: " + elevation;
    var infowindow = new google.maps.InfoWindow({
	content: contentString
    });
    geocoder.geocode({'latLng': location}, function(results, status) {

	geolocation = results[1].formatted_address;
	$('#geolocation').html(geolocation);
	//elevation = 0;
    });
    elevator.getElevationForLocations(positionalRequest, function(results, status) {
	if (status == google.maps.ElevationStatus.OK) {

	    if (results[0]) {
		infowindow.setContent("Latitud: " + lat + "<br> Longitud: " + lng + "<br> Altitud: " + Math.floor(results[0].elevation) + " metros. <br>Ubicación: " + geolocation);
		elevation = Math.floor(results[0].elevation);
		$('#elevationside').html(elevation);
	    } else {
		elevation = "No results found";
	    }
	} else {
	    elevation = "Elevation service failed due to: " + status;
	}
    });
    marker = new google.maps.Marker({
	position: location,
	draggable: true,
	//animation: google.maps.Animation.DROP,
	icon: BASE_URL + 'assets/img/map_icons/mineblack.png',
	map: map
    });
    infowindow.open(map, marker);
    markersAddArray.push(marker);
    $('#lat').val(lat);
    $('#lng').val(lng);

    google.maps.event.addListener(marker, 'dragend', function()
    {
	if (markersAddArray) {
	    for (i in markersAddArray) {
		markersAddArray[i].setMap(null);
	    }
	    markersAddArray.length = 0;
	}
	placeMarker(marker.getPosition());
	console.log(marker.getPosition());
    });
}

function locationFactory() {

    if (latInitial != 0) {
	var locFactory = new google.maps.LatLng(latInitial, lngInitial);
	if (confOperation == 1) {
	    map.setZoom(10);
	} else {
	    map.setZoom(15);
	}
	map.setCenter(locFactory);
	placeMarker(locFactory);
	for (var i = 0; i < areasMarkers.length; i++) {
	    var markerselected = areasMarkers[i];
	    if (markerselected.position.lat() == latInitial) {
		markerselected.setMap(null);
		areasMarkers.splice(i, 1);
	    }

	}
    }
}

/**
 * Se seleccionan/deseleccionnan los marcadores por id
 * @param {array} markersIds
 * @returns {undefined}
 */
function updateMarkersOnMap(markersIds) {

    for (var i = 0; i < areasMarkers.length; i++) {
	var marker = areasMarkers[i];
	if (markersIds.indexOf(marker.id) !== -1) {
	    marker.setIcon(marker.selectedIcon);
	    marker.isSelected = true;
	}
	else {
	    marker.setIcon(marker.neutralIcon);
	    marker.isSelected = false;
	}
    }
}

/**
 * Se seleccionan los marcadores de forma similar a iconos de escritorio de windows
 * @param {marker} marker
 * @param {jstree_node} node
 * @returns {undefined}
 */
function selectMarker(marker, node) {

    // Se seleccionan los marcadores de forma multiple o individual dependiendo de la tecla ctrl
    if (selecting) { // Tecla ctrl presionada

	if (marker.isSelected) {
	    marker.setIcon(marker.neutralIcon);
	    app.getCompanyTree().deselect_node(marker.id, true);
	    marker.isSelected = false;
	}
	else {
	    marker.setIcon(marker.selectedIcon);
	    app.getCompanyTree().select_node(marker.id, true);
	    marker.isSelected = true;
	}
    } else {

	var markerWasSelected = marker.isSelected;

	// Excepcion, el marcador no era el unico seleccionado
	if (areasMarkers.length > 1 && markerWasSelected) {
	    markerWasSelected = false;
	}

	// Se deseleccionan todos los marcadores
	for (var i = 0; i < areasMarkers.length; i++) {

	    var currentMarker = areasMarkers[i];

	    currentMarker.setIcon(currentMarker.neutralIcon);
	    currentMarker.isSelected = false;
	}
	//app.getCompanyTree().deselect_all(true); TODO: recobrar


	// Si el marcador no estaba seleccionado, entonces se selecciona
	if (!markerWasSelected) {
	    marker.setIcon(marker.selectedIcon);
	    //app.getCompanyTree().select_node(marker.id, true); // TODO: recobrar
	    marker.isSelected = true;
	}

	$('#tree-title').html(node.text + '<div class="orange-separator"></div>');
	//$('#attributes').html('');
	//drawAttributes(node.data.attributes);
	app.updateDashboard(marker.id);
    }

    $('#get-indicators-button').prop('disabled', app.getCompanyTree().get_selected().length <= 0);
}

function drawAttributes(attributes) {
    $('#attributes').html('');
    var attrHtml = "<div class='row'>";
    for (var j = 0; j < attributes.length; j++) {
	var attr = attributes[j];
	attrHtml += "<div class='large-13-20'>" + attr.nombre_attr + "</div>";
	attrHtml += "<div class='large-6-20'>" + attr.valor_attr + "</div>";
	attrHtml += "<br/><br/>";
    }

    attrHtml += "</div>";
    $('#attributes').append(attrHtml);
    return attrHtml;
}

function drawContextualMenu(nodeId) {

    var contextualMenuHtml = "<ul class=\"uk-nav uk-nav-navbar\">";
    contextualMenuHtml += '<li class="large-20-20"><a href="javascript:getIndicators()">' + lang.line('task_load_indicators_js') + '</a></li>';
    contextualMenuHtml += '<li class="large-20-20"><a href="javascript:showInformation(' + nodeId + ')">' + lang.line('task_show_information_js') + '</a></li>';
    contextualMenuHtml += '<li class="large-20-20"><a href="javascript: app.loadAddress(\'' + BASE_URL + 'configurador/conf_planta/' + nodeId + '\');">' + lang.line('task_configure_area_js') + '</a></li>';
    contextualMenuHtml += "</ul>";
    return contextualMenuHtml;
}

function getInfoBox(node) {

    var boxText = document.createElement("div");

    // Se preparan los atributos
    var attrHtml = "<div class='row'>";
    for (var j = 0; j < node.data.attributes.length; j++) {
	var attr = node.data.attributes[j];
	attrHtml += "<div class='large-13-20'>" + lang.line('label_' + attr.nombre_attr + '_js') + "</div>";
	attrHtml += "<div class='large-6-20'>" + attr.valor_attr + "</div>";
    }
    attrHtml += "</div>";

    boxText.style.cssText = "border:2px solid black; margin-top: 8px; background:black; color:#FFF; font-family:Arial, Helvetica, sans-serif;  font-size:12px; padding: .5em 1em; -webkit-border-radius: 2px; -moz-border-radius: 2px; border-radius: 2px;  text-shadow:0 -1px #000000; -webkit-box-shadow: 0 0  8px #000;    box-shadow: 0 0 8px #000; max-width: 250px;";
    boxText.innerHTML = '<h4>' + node.text + '</h4>';
    boxText.innerHTML += attrHtml;

    var ib = new InfoBox({
	content: boxText,
	disableAutoPan: false,
	pixelOffset: new google.maps.Size(-20, 0),
	zIndex: null,
	boxStyle: {
	    background: "black",
	    opacity: 0.8
	},
	closeBoxMargin: "12px 4px 2px 2px",
	closeBoxURL: "",
	infoBoxClearance: new google.maps.Size(1, 1)
    });

    return ib;
}

function getContextualMenu(nodeId) {
    var boxText = $('<div id="contextual-box-' + nodeId + '" class="contextual-box"></div>');
    boxText.html(drawContextualMenu(nodeId));

    var ib = new InfoBox({
	content: boxText.html(),
	disableAutoPan: false,
	maxWidth: 300,
	pixelOffset: new google.maps.Size(-20, 0),
	zIndex: null,
	boxStyle: {
	    width: "200px"
	},
	closeBoxMargin: "12px 4px 2px 2px",
	closeBoxURL: "",
	infoBoxClearance: new google.maps.Size(1, 1),
	boxClass: "uk-dropdown-navbar"
    });

    return ib;
}

function mapEventListeners() {
    //Evento que controla el click sobre el mapa para agregar nuevos marcadores
    google.maps.event.addListener(map, 'click', function(event) {
	if (markersAddArray) {
	    for (i in markersAddArray) {
		markersAddArray[i].setMap(null);
	    }
	    markersAddArray.length = 0;
	}
	if (latInitial != null) {
	    placeMarker(event.latLng);
	}
    });

    google.maps.event.addListenerOnce(map, 'idle', function() {

	if (latInitial != null) {
	    locationFactory();
	    if (id_grafo != null && confOperation != 1) {
		$("#jstree").jstree(true).select_node(NODE_TYPE_GRAPH + '.' + id_grafo);
	    }
	}
    });

    // Necesario para cambiar el zoom despues de fitbounds
    google.maps.event.addListener(map, 'zoom_changed', function() {
	zoomChangeBoundsListener =
		google.maps.event.addListener(map, 'bounds_changed', function(event) {
		    if (this.getZoom() > 12 && this.initialZoom == true) {
			// Change max/min zoom here
			this.setZoom(12);
			this.initialZoom = false;
		    }
		    google.maps.event.removeListener(zoomChangeBoundsListener);
		});
    });
}

function showInformation(nodeId) {
    //$("#attributes").show();
    app.open('#right-panel', true);
    var node = app.getCompanyTree().get_node(nodeId);
    app.drawOperationGeneralData(node, METRIC_TYPE_MONTH);
}

function selectChildren(parentSelector, fullDepth, includeParent) {

    var parentNode = app.getCompanyTree().get_node(parentSelector);
    var childrenList = [];

    if (fullDepth)
	childrenList = parentNode.children_d; // Contiene toda la descendencia
    else
	childrenList = parentNode.children; // Contiene solo hijos directos

    if (includeParent)
	childrenList.push(parentSelector);

    for (var i = 0; i < childrenList.length; i++)
	app.getCompanyTree().select_node(childrenList[i]);

}

function deselectChildren(parentSelector, fullDepth, includeParent) {

    var parentNode = app.getCompanyTree().get_node(parentSelector);
    var childrenList = [];

    if (fullDepth)
	childrenList = parentNode.children_d; // Contiene toda la descendencia
    else
	childrenList = parentNode.children; // Contiene solo hijos directos

    if (includeParent)
	childrenList.push(parentSelector);

    for (var i = 0; i < childrenList.length; i++)
	app.getCompanyTree().deselect_node(childrenList[i]);
}

function checkAndGetIndicators(nodeId) {

    var companyTree = app.getCompanyTree();
    companyTree.deselect_all(true);
    companyTree.select_node(nodeId);
    app.open('#left-panel', true);
    app.close('#right-panel', false);

    var node = companyTree.get_node(nodeId);

    if ($('body').hasClass('basic-view')) {
	indicatorsWrapper.loadDashboard(node);
    }
    else {
	getIndicators();
    }
}

function checkAndGetAdvancedIndicators(nodeId) {

    if ($('body').hasClass('basic-view')) {
	setAdvancedView();
    }

    var companyTree = app.getCompanyTree();
    companyTree.deselect_all(true);
    companyTree.select_node(nodeId);
    app.open('#left-panel', true);
    app.close('#right-panel', false);
    app.open('#main-panel', false);

    var node = companyTree.get_node(nodeId);
    indicatorsWrapper.loadDashboard(node);

}

function checkAndGetBasicIndicators(nodeId) {

    if (!$('body').hasClass('basic-view')) {
	setBasicView();
    }

    var companyTree = app.getCompanyTree();
    companyTree.deselect_all(true);
    companyTree.select_node(nodeId);
    app.open('#left-panel', true);
    app.close('#right-panel', false);
    app.open('#main-panel', false);

    var node = companyTree.get_node(nodeId);
    indicatorsWrapper.loadDashboard(node);

}