<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:output method="html" encoding="ISO-8859-1" indent="yes"/>
    <xsl:template match="raiz">
        <HTML class="cuerpo_arial">
            <BODY>
                <xsl:variable name="css">
                    <xsl:value-of select="@css"></xsl:value-of>
                </xsl:variable>
                <link rel="stylesheet" type="text/css" href="{$css}" />
                <TITLE>
                    <xsl:value-of select="@titulo"></xsl:value-of>
                </TITLE>
                <TABLE class="principal" align="center"> 
                    <tbody>
                        <xsl:variable name="logo">
                            <xsl:value-of select="@logo"></xsl:value-of>
                        </xsl:variable>
                        <xsl:variable name="barra_down">
                            <xsl:value-of select="@barra_down"></xsl:value-of>
                        </xsl:variable>
                        <xsl:variable name="foot_text">
                            <xsl:value-of select="@foot_text"></xsl:value-of>
                        </xsl:variable>
                        <TR>
                            <TD>
                                <TABLE class="header">
                                    <TR class="head_tr">
                                        <TD class="head">
                                            <font class="titulo">
                                                <xsl:value-of select="@header"></xsl:value-of>
                                            </font>
                                            <br/>
                                            <xsl:if test="@subtitulo!=''">
                                                <font class="subtitulo">
                                                    <xsl:value-of select="@subtitulo"></xsl:value-of>
                                                </font> 
                                            </xsl:if>
                                            <xsl:if test="@subtitulo2!=''">
                                                <br/>
                                                <font class="subtitulo2">
                                                    <xsl:value-of select="@subtitulo2"></xsl:value-of>
                                                </font>
                                            </xsl:if>
                                        </TD>
                                        <TD class="logo" align="right">
                                            <img src="{$logo}"></img>
                                        </TD>
                                    </TR>
                                </TABLE>
                            </TD>
                        </TR>
                        <TR> 
                            <TD class="head">
                                <TABLE class="fecha">
                                    <TR>
                                        <TD align="left">
                                            <xsl:value-of select="@from"></xsl:value-of>
                                        </TD>
                                        <TD align="left">
                                            <xsl:value-of select="@to"></xsl:value-of>
                                        </TD>
                                    </TR>
                                </TABLE>
                            </TD>
                        </TR>
                        <TR>
                            <TD>
                                <HR class="barra"></HR>
                            </TD>
                        </TR>
                        <TR>
                            <TD>
                                <TABLE width="100%">
                                    <xsl:apply-templates select="decision"></xsl:apply-templates>                                    
                                </TABLE>
                            </TD>
                        </TR>
                        <TR>
                            <TD>
                            </TD>
                        </TR>
                        <TR>
                            <TD>
                                <!--<img src="{$barra_down}"></img>-->
                                <font face ="Arial" size="2px">
                                    <xsl:value-of select="@foot_text"></xsl:value-of>
                                    <xsl:if test="$foot_text!=''">
                                        <sup></sup>
                                    </xsl:if>
                                    
                                </font>
                            </TD>
                        </TR>

                    </tbody>
                </TABLE>
            </BODY>
        </HTML>
    </xsl:template>
    <xsl:template match="decision">
        <xsl:variable name="tipo_central">
            <xsl:value-of select="@tipo_central"></xsl:value-of>
        </xsl:variable>
        
        <xsl:if test="$tipo_central='imagen'"></xsl:if>
        <xsl:apply-templates select="imagen"></xsl:apply-templates>
        <xsl:if test="$tipo_central='tabla'"></xsl:if>
        <xsl:apply-templates select="tabla"></xsl:apply-templates>

    </xsl:template>
    
    <xsl:template match="imagen">
        <xsl:variable name="imagen_body">
            <xsl:value-of select="@imagen_body"></xsl:value-of>
        </xsl:variable>
        <xsl:variable name="width">
            <xsl:value-of select="@width"></xsl:value-of>
        </xsl:variable>
        <xsl:variable name="saltopaginaBefore">
            <xsl:value-of select="@saltopaginaBefore"></xsl:value-of>
        </xsl:variable>
        <xsl:variable name="saltopaginaAfter">
            <xsl:value-of select="@saltopaginaAfter"></xsl:value-of>
        </xsl:variable>
        <xsl:variable name="image_title">
            <xsl:value-of select="@image_title"></xsl:value-of>
        </xsl:variable>
        <xsl:variable name="align">
            <xsl:value-of select="@align"></xsl:value-of>
        </xsl:variable>
        <!--        <div class="{$saltopaginaBefore}"></div>-->
        
        <tr>
            <td>
                <div class="{$saltopaginaBefore}"></div>
                <!-- titulo -->
                <p align="center" class="titulo">
                    <xsl:value-of select="@image_title">
                    </xsl:value-of>
                </p>
                <!-- imagen -->
                <center>
                    <!-- fix coloso -->
                    <img src="{$imagen_body}" align="{$align}" width="{$width}"></img>
                </center>
                <!-- espacio en blanco -->
                <br/>
                <br/>
                <br/>
                <br/>
                <br/>
                <!--<xsl:apply-templates select="emptyspace"></xsl:apply-templates>-->
                
            </td>
        </tr>
        <!-- salto pagina -->
        <div class="{$saltopaginaAfter}"></div>
        
        <xsl:apply-templates select="imagen"></xsl:apply-templates>
    </xsl:template>
    
    <xsl:template match="tabla">
        <xsl:variable name="width">
            <xsl:value-of select="@width"></xsl:value-of>
        </xsl:variable>
        <xsl:variable name="isBold">
            <xsl:value-of select="@isBold"></xsl:value-of>
        </xsl:variable>
        <xsl:variable name="align">
            <xsl:value-of select="@align"></xsl:value-of>
        </xsl:variable>
        <xsl:variable name="table_title">
            <xsl:value-of select="@table_title"></xsl:value-of>
        </xsl:variable>
        <xsl:variable name="saltopaginaBefore">
            <xsl:value-of select="@saltopaginaBefore"></xsl:value-of>
        </xsl:variable>
        <xsl:variable name="saltopaginaAfter">
            <xsl:value-of select="@saltopaginaAfter"></xsl:value-of>
        </xsl:variable>        
        <xsl:variable name="use_bar">
            <xsl:value-of select="@use_bar"></xsl:value-of>
        </xsl:variable>        
        <tr>
            <td>
                <table class="centro" width="{$width}" align ="{$align}">
                    <!--                     Salto paina 
                    -->
                    <div class="{$saltopaginaBefore}"></div>
                    
                    <!-- Titulo tabla -->
                    <tr>
                        <!-- Salto paina -->
                        <!--<div class="{$saltopaginaBefore}"></div>-->
                        <p align="{$align}" class="titulo">
                            <xsl:value-of select="@table_title">
                            </xsl:value-of>
                        </p>
                    </tr>
                    <!-- filas de la tabla -->
                    <xsl:apply-templates select="row"></xsl:apply-templates>
                </table>
                <!-- espacio entre tabla y tabla para que los titulos no se vean tan juntos -->
                
                <xsl:if test="$use_bar='use_bar'">
                    <tr>
                        <td>
                            <HR class="barratablas"></HR>
                        </td>
                    </tr>
                </xsl:if>
            </td>
            
        </tr>
        <!-- salto pagina -->
        <div class="{$saltopaginaAfter}"></div>
    </xsl:template>

    <xsl:template match="row">
        <tr>
            <xsl:apply-templates select="cell"></xsl:apply-templates>
        </tr>
    </xsl:template>
    <!-- espacio en blanco para separar elementos. Usar antes de </td> -->
    <xsl:template match="emptyspace">
        <br/>
        <br/>
        <br/>
        <br/>
        <br/>
    </xsl:template>

    <xsl:template match="cell">
        <xsl:variable name="tipo">
            <xsl:value-of select="@tipo"></xsl:value-of>
        </xsl:variable>
        <xsl:variable name="complex">
            <xsl:value-of select="@complex"></xsl:value-of>
        </xsl:variable>
        <xsl:variable name="data">
            <xsl:value-of select="@data"></xsl:value-of>
        </xsl:variable>
        <xsl:variable name="isHead">
            <xsl:value-of select="@isHead"></xsl:value-of>
        </xsl:variable>
        <xsl:variable name="isBold">
            <xsl:value-of select="@isBold"></xsl:value-of>
        </xsl:variable>
        <xsl:variable name="cellWidth">
            <xsl:value-of select="@cellWidth"></xsl:value-of>
        </xsl:variable>
        <xsl:variable name="noWrap">
            <xsl:value-of select="@noWrap"></xsl:value-of>
        </xsl:variable>
        <xsl:variable name="cellColor">
            <xsl:value-of select="@cellColor"></xsl:value-of>
        </xsl:variable>

        <xsl:if test="$complex='0'">
            <!-- ENCABEZADO -->
            <xsl:if test="$isHead='1'"> 
                <td class="titulos">
                    <xsl:value-of select="@data">
                    </xsl:value-of>
                </td>
            </xsl:if>
            <!-- CELDA NORMAL -->
            <xsl:if test ="$isHead='0'">
                <xsl:variable name="tipo">
                    <xsl:value-of select="@tipo"></xsl:value-of>
                </xsl:variable>
                <xsl:if test="$tipo='1'">
                    <td class="campos">
                        <center>
                            <img src="{$data}"></img>
                        </center>
                    </td>
                </xsl:if>
                <xsl:if test="$tipo='0'">
                    <td class="campos" width="{$cellWidth}" bgcolor="{$cellColor}" style="{$noWrap}">
                        <font class="tabla">
                            <!-- NO negrita -->
                            <xsl:if test="$isBold='0'">
                                <xsl:value-of select="@data"></xsl:value-of>
                            </xsl:if> 
                            <!-- negrita -->
                            <xsl:if test="$isBold='1'">
                                <b>
                                    <xsl:value-of select="@data"></xsl:value-of>
                                </b>
                            </xsl:if>
                            
                            
                        </font>
                    </td>
                </xsl:if>
            </xsl:if>
        </xsl:if>

        <xsl:if test="$complex='1'">
            <xsl:variable name="dataL">
                <xsl:value-of select="@dataL"></xsl:value-of>
            </xsl:variable>
            <xsl:variable name="dataR">
                <xsl:value-of select="@dataR"></xsl:value-of>
            </xsl:variable>
            <td class="campos">
                <xsl:value-of select="@dataL"></xsl:value-of>
                <img src="{$data}"></img>
                <xsl:value-of select="@dataR">
                </xsl:value-of>
            </td>
        </xsl:if>

        <xsl:if test="$complex='2'">
            <xsl:variable name="dataL">
                <xsl:value-of select="@dataL"></xsl:value-of>
            </xsl:variable>
            <xsl:variable name="dataR">
                <xsl:value-of select="@dataR"></xsl:value-of>
            </xsl:variable>
            <td class="campos">
                <xsl:value-of select="@dataL"></xsl:value-of>
                -
                <text></text>
                <xsl:value-of select="@dataR">
                </xsl:value-of>
            </td>
        </xsl:if>

    </xsl:template>
</xsl:stylesheet>